Index: src/Tesselation/triangleintersectionlist.cpp
===================================================================
--- src/Tesselation/triangleintersectionlist.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Tesselation/triangleintersectionlist.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -197,10 +197,33 @@
   if (!DistanceList.empty()) {
     // get closest triangle(s)
-    std::pair< DistanceTriangleMap::iterator, DistanceTriangleMap::iterator >  DistanceRange =
+    std::pair< DistanceTriangleMap::const_iterator, DistanceTriangleMap::const_iterator >  DistanceRange =
         DistanceList.equal_range(DistanceList.begin()->first);
+    {
+      size_t count = 0;
+      for (DistanceTriangleMap::const_iterator iter = DistanceRange.first;
+          iter != DistanceRange.second; ++iter)
+        ++count;
+      LOG(1, "INFO: There are " << count << " possible triangles at the smallest distance.");
+    }
     // if there is more than one, check all of their normal vectors
-    // return the one with positive SKP if present
-
-    runner = IntersectionList.find(DistanceList.begin()->second);
+    // return the one with positive SKP if present because if the point
+    // would be truely inside, all of the closest triangles would have to show
+    // their inner side
+    LOG(1, "INFO: Looking for first SKP greater than zero ...");
+    for (DistanceTriangleMap::const_iterator iter = DistanceRange.first;
+        iter != DistanceRange.second; ++iter) {
+      // find the entry by the triangle key in IntersectionList to get the Intersection point
+      runner = IntersectionList.find(iter->second);
+      Vector TestVector = (Point) - (*(*runner).second);
+      // construct SKP
+      const double sign = (*iter).second->NormalVector.ScalarProduct(TestVector);
+      LOG(1, "INFO: Checking SKP of closest triangle " << *(iter->second) << " = " << sign << ".");
+      // if positive return
+      if (sign > 0)
+        break;
+    }
+    // if there's just one or all are negative, runner is not set yet
+    if (runner == IntersectionList.end())
+      runner = IntersectionList.find(DistanceList.begin()->second);
   }
   return runner;
Index: src/Tesselation/unittests/Makefile.am
===================================================================
--- src/Tesselation/unittests/Makefile.am	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Tesselation/unittests/Makefile.am	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -14,7 +14,6 @@
 TESSELATIONTESTS = \
   TesselationUnitTest \
-  Tesselation_BoundaryTriangleUnitTest
-  
-XFAIL_TESTS += Tesselation_InOutsideUnitTest
+  Tesselation_BoundaryTriangleUnitTest \
+  Tesselation_InOutsideUnitTest
 
 TESTS += $(TESSELATIONTESTS)
Index: src/Tesselation/unittests/Tesselation_BoundaryTriangleUnitTest.cpp
===================================================================
--- src/Tesselation/unittests/Tesselation_BoundaryTriangleUnitTest.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Tesselation/unittests/Tesselation_BoundaryTriangleUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -30,4 +30,7 @@
 #include "Helpers/defs.hpp"
 #include "Atom/TesselPoint.hpp"
+#include "LinearAlgebra/Plane.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+#include "LinearAlgebra/VectorSet.hpp"
 #include "Tesselation/BoundaryPointSet.hpp"
 #include "Tesselation/BoundaryLineSet.hpp"
@@ -49,24 +52,16 @@
 
 
-void TesselationBoundaryTriangleTest::setUp()
-{
-  setVerbosity(5);
+void TesselationBoundaryTriangleTest::createTriangle(const std::vector<Vector> &Vectors)
+{
+  CPPUNIT_ASSERT_EQUAL( (size_t)3, Vectors.size() );
 
   // create nodes
-  tesselpoints[0] = new TesselPoint;
-  tesselpoints[0]->setPosition(Vector(0., 0., 0.));
-  tesselpoints[0]->setName("1");
-  tesselpoints[0]->setNr(1);
-  points[0] = new BoundaryPointSet(tesselpoints[0]);
-  tesselpoints[1] = new TesselPoint;
-  tesselpoints[1]->setPosition(Vector(0., 1., 0.));
-  tesselpoints[1]->setName("2");
-  tesselpoints[1]->setNr(2);
-  points[1] = new BoundaryPointSet(tesselpoints[1]);
-  tesselpoints[2] = new TesselPoint;
-  tesselpoints[2]->setPosition(Vector(1., 0., 0.));
-  tesselpoints[2]->setName("3");
-  tesselpoints[2]->setNr(3);
-  points[2] = new BoundaryPointSet(tesselpoints[2] );
+  for (size_t count = 0; count < NDIM; ++count) {
+    tesselpoints[count] = new TesselPoint;
+    tesselpoints[count]->setPosition( Vectors[count] );
+    tesselpoints[count]->setName(toString(count));
+    tesselpoints[count]->setNr(count);
+    points[count] = new BoundaryPointSet(tesselpoints[count]);
+  }
 
   // create line
@@ -77,7 +72,21 @@
   // create triangle
   triangle = new BoundaryTriangleSet(lines, 0);
-  triangle->GetNormalVector(Vector(0.,0.,1.));
-};
-
+  Plane p(Vectors[0], Vectors[1], Vectors[2]);
+  triangle->GetNormalVector(p.getNormal());
+}
+
+void TesselationBoundaryTriangleTest::setUp()
+{
+  setVerbosity(5);
+
+  // create nodes
+  std::vector<Vector> Vectors;
+  Vectors.push_back( Vector(0., 0., 0.) );
+  Vectors.push_back( Vector(0., 1., 0.) );
+  Vectors.push_back( Vector(1., 0., 0.) );
+
+  // create triangle
+  createTriangle(Vectors);
+}
 
 void TesselationBoundaryTriangleTest::tearDown()
@@ -90,5 +99,213 @@
   logger::purgeInstance();
   errorLogger::purgeInstance();
-};
+}
+
+/** UnitTest for Tesselation::IsInsideTriangle()
+ */
+void TesselationBoundaryTriangleTest::IsInsideTriangleTest()
+{
+  // inside points
+  {
+    // check each endnode
+    for (size_t i=0; i< NDIM; ++i) {
+      const Vector testPoint(triangle->endpoints[i]->node->getPosition());
+      LOG(1, "INFO: Testing whether " << testPoint << " is an inner point.");
+      CPPUNIT_ASSERT( triangle->IsInsideTriangle( testPoint ) );
+    }
+  }
+
+  {
+    // check points along each BoundaryLine
+    for (size_t i=0; i< NDIM; ++i) {
+      Vector offset = triangle->endpoints[i%3]->node->getPosition();
+      Vector direction = triangle->endpoints[(i+1)%3]->node->getPosition() - offset;
+      for (double s = 0.1; s < 1.; s+= 0.1) {
+        Vector testPoint = offset + s*direction;
+        LOG(1, "INFO: Testing whether " << testPoint << " is an inner point.");
+        CPPUNIT_ASSERT( triangle->IsInsideTriangle( testPoint ) );
+      }
+    }
+  }
+
+  {
+    // check central point
+    Vector center;
+    triangle->GetCenter(center);
+    LOG(1, "INFO: Testing whether " << center << " is an inner point.");
+    CPPUNIT_ASSERT( triangle->IsInsideTriangle( center ) );
+  }
+
+  // outside points
+  {
+    // check points outside (i.e. those not in xy-plane through origin)
+    double n[3];
+    const double boundary = 4.;
+    const double step = 1.;
+    // go through the cube and check each point
+    for (n[0] = -boundary; n[0] <= boundary; n[0]+=step)
+      for (n[1] = -boundary; n[1] <= boundary; n[1]+=step)
+        for (n[2] = -boundary; n[2] <= boundary; n[2]+=step) {
+          const Vector testPoint(n[0], n[1], n[2]);
+          if (n[2] != 0) {
+            LOG(1, "INFO: Testing whether " << testPoint << " is not an inner point.");
+            CPPUNIT_ASSERT( !triangle->IsInsideTriangle( testPoint ) );
+          }
+        }
+  }
+
+  {
+    // check points within the plane but outside of triangle
+    double n[3];
+    const double boundary = 4.;
+    const double step = 1.;
+    n[2] = 0;
+    for (n[0] = -boundary; n[0] <= boundary; n[0]+=step)
+      for (n[1] = -boundary; n[1] <= boundary; n[1]+=step) {
+        const Vector testPoint(n[0], n[1], n[2]);
+        if ((n[0] >=0) && (n[1] >=0) && (n[0]<=1) && (n[1]<=1)) {
+          if (n[0]+n[1] <= 1) {
+            LOG(1, "INFO: Testing whether " << testPoint << " is an inner point.");
+            CPPUNIT_ASSERT( triangle->IsInsideTriangle( testPoint) );
+          } else {
+            LOG(1, "INFO: Testing whether " << testPoint << " is not an inner point.");
+            CPPUNIT_ASSERT( !triangle->IsInsideTriangle( testPoint) );
+          }
+        } else {
+          LOG(1, "INFO: Testing whether " << testPoint << " is not an inner point.");
+          CPPUNIT_ASSERT( !triangle->IsInsideTriangle( testPoint) );
+        }
+      }
+  }
+}
+
+/** UnitTest for Tesselation::IsInsideTriangle()
+ *
+ * We test for some specific points that occured in larger examples of the code.
+ *
+ */
+void TesselationBoundaryTriangleTest::IsInsideTriangle_specificTest()
+{
+  {
+    delete triangle;
+    // test is from --create-micelle 200 --radius 30. --position "0,0,0" of sles.data
+    // failure is: Intersection (23.1644,24.1867,65.1272) is not inside triangle [659|Na2451,O3652,Na3762].
+    const Vector testPoint(1.57318,1.57612,10.9874);
+    const Vector testIntersection(23.1644,24.1867,65.1272);
+    std::vector<Vector> vectors;
+    vectors.push_back( Vector(23.0563,30.4673,73.7555) );
+    vectors.push_back( Vector(25.473,25.1512,68.5467) );
+    vectors.push_back( Vector(23.1644,24.1867,65.1272) );
+    createTriangle(vectors);
+    CPPUNIT_ASSERT( triangle->IsInsideTriangle( testIntersection ) );
+  }
+  {
+    delete triangle;
+    // test is from --create-micelle 200 --radius 30. --position "0,0,0" of sles.data
+    // failure is: Intersection (20.6787,70.655,71.5657) is not inside triangle [622|Na1197,Na2166,O3366].
+    // fix is lower LINALG_MYEPSILON (not std::numeric_limits<doubble>*100 but *1e-4)
+    const Vector testPoint(1.57318,14.185,61.2155);
+    const Vector testIntersection(20.67867516517798,70.65496977054023,71.56572984946152);
+    std::vector<Vector> vectors;
+    vectors.push_back( Vector(22.9592,68.7791,77.5907) );
+    vectors.push_back( Vector(18.4729,72.0386,68.08839999999999) );
+    vectors.push_back( Vector(20.3834,71.0154,70.1443) );
+    createTriangle(vectors);
+    CPPUNIT_ASSERT( triangle->IsInsideTriangle( testIntersection ) );
+  }
+  {
+    delete triangle;
+    // test is from --create-micelle 200 --radius 30. --position "0,0,0" of sles.data
+    // failure is:Intersection (27.56537519896,13.40256646925,6.672946688134) is not inside triangle [702|Na5016,O6388,Na6498].
+    // note that the Intersection cannot possibly lie be within the triangle!
+    // we test now against correct intersection
+    const Vector testIntersection(14.6872,36.204,39.8043);
+    std::vector<Vector> vectors;
+    vectors.push_back( Vector(10.7513,43.4247,48.4127) );
+    vectors.push_back( Vector(13.7119,37.0827,47.4203) );
+    vectors.push_back( Vector(14.6872,36.204,39.8043) );
+    createTriangle(vectors);
+    CPPUNIT_ASSERT( triangle->IsInsideTriangle( testIntersection ) );
+  }
+}
+
+/** UnitTest for Tesselation::GetClosestPointInsideTriangle()
+ *
+ * We check whether this function always returns a intersection inside the
+ * triangle.
+ *
+ */
+void TesselationBoundaryTriangleTest::GetClosestPointInsideTriangleTest()
+{
+  Vector TestIntersection;
+
+  {
+    // march through a cube mesh on triangle in xy plane
+    double n[3];
+    const double boundary = 4.;
+    const double step = 1.;
+    // go through the cube and check each point
+    for (n[0] = -boundary; n[0] <= boundary; n[0]+=step)
+      for (n[1] = -boundary; n[1] <= boundary; n[1]+=step)
+        for (n[2] = -boundary; n[2] <= boundary; n[2]+=step) {
+          const Vector testPoint(n[0], n[1], n[2]);
+          triangle->GetClosestPointInsideTriangle(testPoint, TestIntersection);
+          CPPUNIT_ASSERT( triangle->IsInsideTriangle( TestIntersection ));
+        }
+  }
+
+  delete triangle;
+  // create better triangle;
+  VECTORSET(std::vector) Vectors;
+  Vectors.push_back( Vector(0., 0., 0.) );
+  Vectors.push_back( Vector(0., 1., 0.) );
+  Vectors.push_back( Vector(1., 0., 0.) );
+  RealSpaceMatrix M;
+  M.setRotation(M_PI/3., M_PI/4., 2.*M_PI/3.);
+  Vectors.transform(M);
+  createTriangle(Vectors);
+
+  {
+    // march through a cube mesh on rotated triangle
+    double n[3];
+    const double boundary = 4.;
+    const double step = 1.;
+    // go through the cube and check each point
+    for (n[0] = -boundary; n[0] <= boundary; n[0]+=step)
+      for (n[1] = -boundary; n[1] <= boundary; n[1]+=step)
+        for (n[2] = -boundary; n[2] <= boundary; n[2]+=step) {
+          const Vector testPoint(n[0], n[1], n[2]);
+          triangle->GetClosestPointInsideTriangle(testPoint, TestIntersection);
+          CPPUNIT_ASSERT( triangle->IsInsideTriangle( TestIntersection ));
+        }
+  }
+}
+
+/** UnitTest for Tesselation::GetClosestPointInsideTriangle()
+ *
+ * We test for some specific points that occured in larger examples of the code.
+ *
+ */
+void TesselationBoundaryTriangleTest::GetClosestPointInsideTriangle_specificTest()
+{
+  {
+    delete triangle;
+    // test is from --create-micelle 200 --radius 30. --position "0,0,0" of sles.data
+    // failure is:Intersection (27.56537519896,13.40256646925,6.672946688134) is not inside triangle [702|Na5016,O6388,Na6498].
+    // note that the Intersection cannot possibly lie be within the triangle
+    // however, it is on its plane (off only by 2.7e-12)
+    // testPoint2 is corrected version
+    const Vector testPoint(27.56537519896,13.40256646925,6.672946688134);
+    const Vector testPoint2(14.6872,36.204,39.8043);
+    Vector testIntersection;
+    std::vector<Vector> vectors;
+    vectors.push_back( Vector(10.7513,43.4247,48.4127) );
+    vectors.push_back( Vector(13.7119,37.0827,47.4203) );
+    vectors.push_back( Vector(14.6872,36.204,39.8043) );
+    createTriangle(vectors);
+    triangle->GetClosestPointInsideTriangle(testPoint, testIntersection);
+    CPPUNIT_ASSERT ( testPoint != testIntersection );
+    CPPUNIT_ASSERT ( testPoint2 == testIntersection );
+  }
+}
 
 /** UnitTest for Tesselation::IsInnerPoint()
Index: src/Tesselation/unittests/Tesselation_BoundaryTriangleUnitTest.hpp
===================================================================
--- src/Tesselation/unittests/Tesselation_BoundaryTriangleUnitTest.hpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Tesselation/unittests/Tesselation_BoundaryTriangleUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -19,4 +19,7 @@
 #include <cppunit/extensions/HelperMacros.h>
 
+#include <vector>
+
+#include "LinearAlgebra/Vector.hpp"
 #include "LinkedCell/linkedcell.hpp"
 #include "Tesselation/tesselation.hpp"
@@ -29,4 +32,8 @@
 {
     CPPUNIT_TEST_SUITE( TesselationBoundaryTriangleTest) ;
+    CPPUNIT_TEST ( IsInsideTriangleTest );
+    CPPUNIT_TEST ( IsInsideTriangle_specificTest );
+    CPPUNIT_TEST ( GetClosestPointInsideTriangleTest );
+    CPPUNIT_TEST ( GetClosestPointInsideTriangle_specificTest );
     CPPUNIT_TEST ( GetClosestPointOnPlaneTest );
     CPPUNIT_TEST ( GetClosestPointOffPlaneTest );
@@ -36,8 +43,14 @@
       void setUp();
       void tearDown();
+      void IsInsideTriangleTest();
+      void IsInsideTriangle_specificTest();
+      void GetClosestPointInsideTriangleTest();
+      void GetClosestPointInsideTriangle_specificTest();
       void GetClosestPointOnPlaneTest();
       void GetClosestPointOffPlaneTest();
 
 private:
+      void createTriangle(const std::vector<Vector> &Vectors);
+
       static const double SPHERERADIUS;
 
Index: src/UIElements/CommandLineUI/CommandLineParser.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineParser.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/UIElements/CommandLineUI/CommandLineParser.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -51,4 +51,5 @@
   atom("Atom options"),
   command("Command options"),
+  fill("fill options"),
   fragmentation("Fragmentation options"),
   graph("Graph options"),
@@ -65,4 +66,5 @@
   CmdParserLookup["command"] = &command;
   CmdParserLookup["edit"] = &edit;
+  CmdParserLookup["fill"] = &fill;
   CmdParserLookup["fragmentation"] = &fragmentation;
   CmdParserLookup["graph"] = &graph;
Index: src/UIElements/CommandLineUI/CommandLineParser.hpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineParser.hpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/UIElements/CommandLineUI/CommandLineParser.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -58,4 +58,5 @@
   po::options_description command;
   po::options_description edit;
+  po::options_description fill;
   po::options_description fragmentation;
   po::options_description graph;
Index: src/UIElements/Makefile.am
===================================================================
--- src/UIElements/Makefile.am	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/UIElements/Makefile.am	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -263,4 +263,5 @@
 	libMolecuilderAnalysis.la \
 	libMolecuilderGraph.la \
+	libMolecuilderFilling.la \
 	libMolecuilder.la \
 	libMolecuilderFragmentation.la \
Index: src/UIElements/Menu/MenuDescription.cpp
===================================================================
--- src/UIElements/Menu/MenuDescription.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/UIElements/Menu/MenuDescription.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -49,4 +49,5 @@
   MenuPositionMap->insert(std::make_pair("command",TopPosition("",3)));
   MenuPositionMap->insert(std::make_pair("edit",TopPosition("",2)));
+  MenuPositionMap->insert(std::make_pair("fill",TopPosition("tools",5)));
   MenuPositionMap->insert(std::make_pair("fragmentation",TopPosition("tools",3)));
   MenuPositionMap->insert(std::make_pair("graph",TopPosition("tools",4)));
@@ -63,4 +64,5 @@
   MenuDescriptionsMap->insert(std::make_pair("command","Configuration"));
   MenuDescriptionsMap->insert(std::make_pair("edit","Edit"));
+  MenuDescriptionsMap->insert(std::make_pair("fill","Fill"));
   MenuDescriptionsMap->insert(std::make_pair("fragmentation","Fragmentation"));
   MenuDescriptionsMap->insert(std::make_pair("graph","Graph"));
@@ -77,4 +79,5 @@
   MenuNameMap->insert(std::make_pair("command","Configuration"));
   MenuNameMap->insert(std::make_pair("edit","Edit"));
+  MenuNameMap->insert(std::make_pair("fill","Fill"));
   MenuNameMap->insert(std::make_pair("fragmentation","Fragmentation"));
   MenuNameMap->insert(std::make_pair("graph","Graph"));
Index: src/documentation/constructs/atoms.dox
===================================================================
--- src/documentation/constructs/atoms.dox	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/documentation/constructs/atoms.dox	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -56,5 +56,28 @@
  * compatible implementation.
  *
+ * \section atoms-copy Copying atoms
  *
- * \date 2011-10-31
+ * Copying atoms is a frequent action. That's why there are specific functors
+ * to get it done in more and more complex ways. The functors all inherit
+ * the \ref CopyAtomsInterface and the more complex ones build upon the
+ * functionality of the simpler ones:
+ * -# CopyAtomsInterface: Internally sets to the number of desired atoms.
+ * -# CopyAtoms_Simple: Fills the internal set with true copies.
+ * -# CopyAtoms_withBonds: Additionally also adds bonds in between the copies
+ *    as they exist in between the original atoms.
+ * -# CopyAtoms_SaturateDanglingBonds: additionally checks for cut bond that
+ *    would now become dangling bonds and inserts additional hydrogens for
+ *    each cut bond such that the copied array of atoms is saturated.
+ *
+ * The CopyAtomsInterface is simple to use:
+ * \code
+ *   std::vector<atom *> atoms_to_copy;
+ *   CopyAtoms_Simple copyMethod;
+ *   copyMethod(atoms_to_copy);
+ *   std::vector<atom *> copiedAtoms = getCopiedAtoms();
+ * \endcode
+ *
+ *
+ * \date 2012-03-30
+ *
  */
Index: src/documentation/constructs/constructs.dox
===================================================================
--- src/documentation/constructs/constructs.dox	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/documentation/constructs/constructs.dox	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -2,5 +2,5 @@
  * Project: MoleCuilder
  * Description: creates and alters molecular systems
- * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Copyright (C)  2011-2012 University of Bonn. All rights reserved.
  * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
  */
@@ -22,4 +22,5 @@
  *  \li \ref atom
  *  \li \ref bondgraph
+ *  \li \ref filling
  *  \li \ref descriptors
  *  \li \ref fragmentation
@@ -41,5 +42,5 @@
  *
  *
- * \date 2012-01-05
+ * \date 2012-01-16
  *
  */
Index: src/documentation/constructs/filling.dox
===================================================================
--- src/documentation/constructs/filling.dox	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/documentation/constructs/filling.dox	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,78 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/**
+ * \file filling.dox
+ *
+ * Created on: Jan 16, 2012
+ *    Author: heber
+ */
+
+/** \page filling Filling a domain
+ *
+ * The idea behind filling a domain is to cluster it with a set of nodes,
+ * i.e. a position in space in such a way that e.g. around node is sufficient
+ * space to fill in the desired molecule. The logic of generating the nodes
+ * is responsible to create them in such a way as to allow for dense (or
+ * whatever specific) filling is desired. However, we must not make it too
+ * complicated. The generation logic for these nodes should concentrate on
+ * filling the specific domain (sphere, ellipsoid, cuboid, pyramid, ...)
+ * in the best possible way.
+ * Whether each node can be filled is then to be decided by a predicate.
+ *
+ * The filling routine uses then both to traverse the given nodes and
+ * evaluate the predicate at each.
+ *
+ * Hence, the filling of a domain is abstracted into the following parts:
+ *
+ *  -# \ref Mesh - node containers
+ *  -# \ref FillPredicate - predicates
+ *  -# \ref Filler - a filling routine which itself requires
+ *    -# \ref Cluster - a set of atoms alone(!) inside a specific Shape
+ *    -# \ref CopyAtomsInterface - copy Method for atoms used by Cluster::clone
+ *    -# \ref Inserter - an insertion routine for the cloned cluster
+ *
+ * \section filling-node-generation Node generation
+ *
+ * The node generation is basically just a point or mesh generator that fills
+ * a specified region (best would be based on the class Shape) with a mesh in
+ * such a way as to fulfill certain criteria:
+ *
+ *    -# equidistant
+ *    -# containing certain primitive volumes (e.g. for fitting polymers)
+ *    -# ...
+ *
+ * \section filling-predicate Predicates
+ *
+ * The Predicate pattern has already been used with Descriptors and Shapes.
+ * These are simply function objects that return a boolean value. I.e. they
+ * decide whether the current node in the mesh is vacant and can be filled or
+ * not. As with the predicate() function in the class Descriptor, these should
+ * be composable via logic operators such as || (or), && (and), ! (not), ...
+ *
+ * Note that each predicate receives on construction all the required
+ * information, e.g. LinkedCell_View or Tesselation references or objects, ...
+ *
+ * \section filling-filling-routine Filling routine
+ *
+ * The filling routine is then simply a function that goes through the given
+ * number of nodes (completely unaware of the geometry) and evaluates for each
+ * point the given predicates (which might be a composition of other predicates).
+ *
+ * It rejects all nodes that evaluate to false, the list of valid points is
+ * then traversed again and at each node a Cluster is created.
+ *
+ * Note that we rely on \ref Cluster's, objects containing a set of atomicId_t
+ * and that are inside a contained \ref Shape, to fill at each node. We use
+ * Cluster::clone() to create a copy that is subsequently placed at the desired
+ * node via an \ref Inserter functor. This allows to either simply shift the
+ * Cluster or even to perform some random translations and rotations on it, see
+ * the specific implementations of the class \ref Inserter.
+ *
+ *
+ * \date 2012-01-16
+ */
Index: src/molecule.cpp
===================================================================
--- src/molecule.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/molecule.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -44,4 +44,5 @@
 #include "LinkedCell/linkedcell.hpp"
 #include "IdPool_impl.hpp"
+#include "Shapes/BaseShapes.hpp"
 #include "Tesselation/tesselation.hpp"
 #include "World.hpp"
@@ -165,34 +166,4 @@
 /************************** Access to the List of Atoms ****************/
 
-
-molecule::iterator molecule::begin(){
-  return iterator(atomIds.begin(), FromIdToAtom());
-}
-
-molecule::const_iterator molecule::begin() const{
-  return const_iterator(atomIds.begin(), FromIdToAtom());
-}
-
-molecule::iterator molecule::end(){
-  return iterator(atomIds.end(), FromIdToAtom());
-}
-
-molecule::const_iterator molecule::end() const{
-  return const_iterator(atomIds.end(), FromIdToAtom());
-}
-
-bool molecule::empty() const
-{
-  return (atomIds.empty());
-}
-
-size_t molecule::size() const
-{
-  size_t counter = 0;
-  for (const_iterator iter = begin(); iter != end (); ++iter)
-    counter++;
-  return counter;
-}
-
 molecule::const_iterator molecule::erase( const_iterator loc )
 {
@@ -222,18 +193,13 @@
 }
 
-molecule::const_iterator molecule::find ( atom * key ) const
-{
-  return const_iterator(atomIds.find(key->getId()), FromIdToAtom());
-}
-
 pair<molecule::iterator,bool> molecule::insert ( atom * const key )
 {
   OBSERVE;
-  pair<atomIdSet::iterator,bool> res = atomIds.insert(key->getId());
+  std::pair<iterator,bool> res = atomIds.insert(key->getId());
   if (res.second) { // push atom if went well
     key->setNr(atomIdPool.getNextId());
     setAtomName(key);
     formula+=key->getType();
-    return pair<iterator,bool>(iterator(res.first, FromIdToAtom()),res.second);
+    return res;
   } else {
     return pair<iterator,bool>(end(),res.second);
@@ -256,10 +222,4 @@
 {
   World::AtomComposite vector_of_atoms;
-//  std::copy(MyIter(atomIds.begin(), FromIdToAtom()),
-//      MyIter(atomIds.end(), FromIdToAtom()),
-//      vector_of_atoms.begin());
-//  for (MyIter iter = MyIter(atomIds.begin(), FromIdToAtom());
-//      iter != MyIter(atomIds.end(), FromIdToAtom());
-//      ++iter)
   for (molecule::iterator iter = begin(); iter != end(); ++iter)
     vector_of_atoms.push_back(*iter);
@@ -589,7 +549,8 @@
 
 /** Creates a copy of this molecule.
+ * \param offset translation Vector for the new molecule relative to old one
  * \return copy of molecule
  */
-molecule *molecule::CopyMolecule() const
+molecule *molecule::CopyMolecule(const Vector &offset) const
 {
   molecule *copy = World::getInstance().createMolecule();
@@ -599,4 +560,5 @@
   for (iterator iter = begin(); iter != end(); ++iter) {
     atom * const copy_atom = copy->AddCopyAtom(*iter);
+    copy_atom->setPosition(copy_atom->getPosition() + offset);
     FatherFinder.insert( std::make_pair( *iter, copy_atom ) );
   }
@@ -851,5 +813,5 @@
       "molecule::isInMolecule() - atom is not designated to be in molecule '"
       +toString(this->getName())+"'.");
-  molecule::atomIdSet::const_iterator iter = atomIds.find(_atom->getId());
+  molecule::const_iterator iter = atomIds.find(_atom->getId());
   return (iter != atomIds.end());
 }
@@ -1063,4 +1025,33 @@
 }
 
+Shape molecule::getBoundingShape() const
+{
+  // get center and radius
+  Vector center;
+  double radius = 0.;
+  {
+    center.Zero();
+    for(const_iterator iter = begin(); iter != end(); ++iter)
+      center += (*iter)->getPosition();
+    center *= 1./(double)size();
+    for(const_iterator iter = begin(); iter != end(); ++iter) {
+      const Vector &position = (*iter)->getPosition();
+      const double temp_distance = position.DistanceSquared(center);
+      if (temp_distance > radius)
+        radius = temp_distance;
+    }
+  }
+  // convert radius to true value and add some small boundary
+  radius = sqrt(radius) + 1e+6*std::numeric_limits<double>::epsilon();
+  LOG(1, "INFO: The " << size() << " atoms of the molecule are contained in a sphere at "
+      << center << " with radius " << radius << ".");
+
+  Shape BoundingShape(Sphere(center, radius));
+  LOG(1, "INFO: Created sphere at " << BoundingShape.getCenter() << " and radius "
+      << BoundingShape.getRadius() << ".");
+  return BoundingShape;
+}
+
 // construct idpool
 CONSTRUCT_IDPOOL(atomId_t, continuousId)
+
